/*
  Name : carte.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a k8055 card
*/

#ifndef _CARTE_HPP_
#define _CARTE_HPP_


#define PRESENTE 1

#include "util.h"
#include <K8055DLL.h>
#include <fcntl.h>
#include <iomanip>
#include <usb.h>
#include "shareData.hpp"

// K8055 ana input
#define INP_TEMP 1 // temperature captor



// insert error type in table error + log
void insert_error(connexion &c,short type);


class K8055
{
private:
 

public:
  long uh;

  K8055(connexion &);
  ~K8055();
  void init (connexion &);	//initialize the K8055
  void arret();			//close device
  void change_state(connexion &, short ,short ,string );	//change the state of the module of the 3rd argument 
  void print_status(long ,config &);	//print all modules' state
  int read(int);	//read digital channels on the card
  double readAnalog(int);
  void resetcounter(int); // reset digital counter
  double readcounter(int); //read counter

};

#endif
