/*
  Name :temperature.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a temperature captor
*/

#ifndef _TEMPERATURE_HPP_
#define _TEMPERATURE_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Temperature:public Objet
{
private:
  bool sup30;	//if the temperature is higher than 30C
  bool inf24;	//if the temperature is lower than 24C
 
  void forceState(short,connexion &,K8055 &,config &);	//force the state of the captor
  void stopper (connexion&,K8055&,config&);	//stop the heating
  void start (connexion&,K8055&,config&);	//start the heating	
public:
  time_t timer;

  Temperature(){}
  void init();		//initialize the temperature captor

  bool getsup30();
  bool getinf24();
  
  void setSup30 (bool);
  void setInf24 (bool);

  
  double give(double t[10]);	// used to give the more relevant temperature according to 10 values not the best perf but tab 10


  void tempState(double,connexion &,K8055&,config &);	//check the state of the temp captor

};

#endif
