#include "stdafx.h"
#include "cphidgetaccelerometer.h"
#include "cusb.h"
#include "math.h"
#include "csocket.h"
#include "cthread.h"

CFHANDLE(Accelerometer,Acceleration) int, double), void *userPtr)
ASGNFPTR(Accelerometer,Acceleration)

CMAKEPACKET_BUF(Accelerometer, outputPacket, outputPacketLen)

CPHIDGETDATA(Accelerometer)
	int i;
	double dx=0,dy=0,dz=0;
	TESTPTR(phid);
	//printf("Accelerometer_DataInput called\n");
	switch(phidG->deviceIDSpec)
	{
		case PHIDSPEC_ACCELEROMETER:
			if (phidG->deviceVersion < 200)
			{
				i = (signed short)((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				dx = (((double)i-16384) / 2000);
				i = (signed short)((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				dy = (((double)i-16384) / 2000);
			}
			if ((phidG->deviceVersion  >= 200) && (phidG->deviceVersion  < 300))
			{
				i = (signed short)((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				dx = (((double)i-16384) / 650);
				i = (signed short)((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				dy = (((double)i-16384) / 650);
			}
			if ((phidG->deviceVersion  >= 300) && (phidG->deviceVersion  < 400))
			{
				i = ((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				//printf("%d ", i);
				dx = (((double)(i-32768)) / 4000);
				i = ((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				//printf("%d ", i);
				dy = (((double)(i-32768)) / 4000);
			}
			break;
		case PHIDSPEC_ACCELEROMETER3:
			if ((phidG->deviceVersion  >= 400) && (phidG->deviceVersion  < 500))
			{
				i = ((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				//printf("%d ", i);
				dx = (((double)(i-32768)) / 6553);
				i = ((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				//printf("%d ", i);
				dy = (((double)(i-32768)) / 6553);
				i = ((unsigned short)buffer[4]+((unsigned short)buffer[5]<<8));
				//printf("%d ", i);
				dz = (((double)(i-32768)) / 6553);
			}
			break;
		case PHIDSPEC_ACCELEROMETER_with_GYRO:
			if (phidG->deviceVersion  < 200)
			{
				i = ((unsigned short)buffer[0]+((unsigned short)buffer[1]<<8));
				//printf("%d ", i);
				dx = (((double)(i-32768)) / 6553);
				i = ((unsigned short)buffer[2]+((unsigned short)buffer[3]<<8));
				//printf("%d ", i);
				dy = (((double)(i-32768)) / 6553);
				i = ((unsigned short)buffer[4]+((unsigned short)buffer[5]<<8));
				//printf("%d ", i);
				dz = (((double)(i-32768)) / 6553);
			}
			break;
		default:
			break;
	}


	phid->axis[0] = dx;
	phid->axis[1] = dy;
	phid->axis[2] = dz;

	if (fabs(dx - phid->axisLastTrigger[0]) > phid->axisChangeTrigger[0])
	{
		FIRE(Acceleration) 0, dx);
		phid->axisLastTrigger[0] = dx;
	}
	if (fabs(dy - phid->axisLastTrigger[1]) > phid->axisChangeTrigger[1])
	{
		FIRE(Acceleration) 1, dy);
		phid->axisLastTrigger[1] = dy;
	}
	if (fabs(dz - phid->axisLastTrigger[2]) > phid->axisChangeTrigger[2])
	{
		FIRE(Acceleration) 2, dz);
		phid->axisLastTrigger[2] = dz;
	}

	return EPHIDGET_OK;
}

CSETINDEX(Accelerometer,AccelerationChangeTrigger,double)
	TESTPTR(phid) 
	TESTRNG1(phid.attr.accelerometer.numAxis)
	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Trigger, "%lf")
	else
		phid->axisChangeTrigger[Index] = newVal;
	return EPHIDGET_OK;
}

CGETINDEX(Accelerometer,Acceleration,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.accelerometer.numAxis)
	MASGN(axis[Index]);
}

CGETINDEX(Accelerometer,AccelerationChangeTrigger,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.accelerometer.numAxis)
	MASGN(axisChangeTrigger[Index])
}

CGET(Accelerometer,NumAxis,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.accelerometer.numAxis)
}

CPHIDGETINIT(Accelerometer)
	phid = 0;
	return EPHIDGET_OK;
}

CCREATE(Accelerometer, PHIDDEF_ACCELEROMETER)
