#ifndef __CPHIDGETINTERFACEKIT
#define __CPHIDGETINTERFACEKIT

typedef struct _CPhidgetInterfaceKit __CPhidgetInterfaceKit;
typedef __CPhidgetInterfaceKit *CPhidgetInterfaceKitHandle;

PHIDGET21_API int CCONV CPhidgetInterfaceKit_create(CPhidgetInterfaceKitHandle *);

PHIDGET21_API int CCONV CPhidgetInterfaceKit_getOutputState(CPhidgetInterfaceKitHandle, int Index, int *pVal); 
PHIDGET21_API int CCONV CPhidgetInterfaceKit_setOutputState(CPhidgetInterfaceKitHandle, int Index, int newVal);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_getSensorChangeTrigger(CPhidgetInterfaceKitHandle, int Index, int *pVal); 
PHIDGET21_API int CCONV CPhidgetInterfaceKit_setSensorChangeTrigger(CPhidgetInterfaceKitHandle, int Index, int newVal);

PHIDGET21_API int CCONV CPhidgetInterfaceKit_getNumInputs(CPhidgetInterfaceKitHandle, int *pVal);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_getNumOutputs(CPhidgetInterfaceKitHandle, int *pVal);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_getNumSensors(CPhidgetInterfaceKitHandle, int *pVal);

PHIDGET21_API int CCONV CPhidgetInterfaceKit_getInputState(CPhidgetInterfaceKitHandle, int Index, int *pVal);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_getSensorValue(CPhidgetInterfaceKitHandle, int Index, int *pVal);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_getSensorRawValue(CPhidgetInterfaceKitHandle, int Index, int *pVal);

PHIDGET21_API int CCONV CPhidgetInterfaceKit_getRatiometric(CPhidgetInterfaceKitHandle, int *pVal); 
PHIDGET21_API int CCONV CPhidgetInterfaceKit_setRatiometric(CPhidgetInterfaceKitHandle, int newVal);

PHIDGET21_API int CCONV CPhidgetInterfaceKit_set_OnInputChange_Handler(
    CPhidgetInterfaceKitHandle, int (CCONV *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_set_OnOutputChange_Handler(
    CPhidgetInterfaceKitHandle, int (CCONV *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);
PHIDGET21_API int CCONV CPhidgetInterfaceKit_set_OnSensorChange_Handler(
    CPhidgetInterfaceKitHandle, int (CCONV *fptr)(CPhidgetInterfaceKitHandle,
    void *, int, int), void *);


#ifndef EXTERNALPROTO
#define IFKIT_MAXINPUTS 32
#define IFKIT_MAXOUTPUTS 32
#define IFKIT_MAXSENSORS 8
struct _CPhidgetInterfaceKit {
	CPhidget phid;

	int (CCONV *fptrOutputChange)(CPhidgetInterfaceKitHandle, void *, int,
	    int);
	int (CCONV *fptrInputChange)(CPhidgetInterfaceKitHandle, void *, int,
	    int);
	int (CCONV *fptrSensorChange)(CPhidgetInterfaceKitHandle, void *, int,
	    int);

	void *fptrOutputChangeptr;
	void *fptrInputChangeptr;
	void *fptrSensorChangeptr;

	int ratiometric;

	// output fields all protected by outputLock
	unsigned char outputStates[IFKIT_MAXOUTPUTS];
	unsigned char nextOutputStates[IFKIT_MAXOUTPUTS];
	unsigned char changedOutputs[IFKIT_MAXOUTPUTS];
	unsigned char lastChangedOutput;

	unsigned char outputEchoStates[IFKIT_MAXOUTPUTS];		// Values returned from the device
	unsigned char physicalState[IFKIT_MAXINPUTS];

	unsigned short sensorChangeTrigger[IFKIT_MAXSENSORS];
	unsigned short sensorRawValue[IFKIT_MAXSENSORS];
	unsigned short sensorValue[IFKIT_MAXSENSORS];
	unsigned short sensorLastValue[IFKIT_MAXSENSORS];

	char fullStateEcho;
};
#endif

#endif
