#ifndef __CPHIDGETMOTORCONTROL
#define __CPHIDGETMOTORCONTROL



DPHANDLE(MotorControl)

CHDRSTANDARD(MotorControl)
CHDRGET(MotorControl,NumInputs,PINTEGER)
CHDRGET(MotorControl,NumMotors,PINTEGER)
CHDRGETINDEX(MotorControl,InputState,PINTEGER)
CHDRGETSETINDEX(MotorControl,Acceleration,PDOUBLE)
CHDRGETSETINDEX(MotorControl,MotorSpeed,PDOUBLE)

CHDREVENTINDEX(MotorControl,InputChange,PINTEGER)
CHDREVENTINDEX(MotorControl,MotorChange,PDOUBLE)
CHDREVENTINDEX(MotorControl,CurrentChange,PDOUBLE)

#ifndef EXTERNALPROTO
#define MOTORCONTROL_MAXMOTORS 2
#define MOTORCONTROL_MAXINPUTS 4
struct _CPhidgetMotorControl {
	CPhidget phid;

	int (CCONV *fptrMotorChange)(CPhidgetMotorControlHandle, void *, int, double);                 
	int (CCONV *fptrInputChange)(CPhidgetMotorControlHandle, void *, int, int);     
	int (CCONV *fptrCurrentChange)(CPhidgetMotorControlHandle, void *, int, double);       

	void *fptrInputChangeptr;
	void *fptrMotorChangeptr;
	void *fptrCurrentChangeptr;

	unsigned char inputStates[MOTORCONTROL_MAXINPUTS];
	double motorPWMCurrent[MOTORCONTROL_MAXMOTORS];
	double motorSensedCurrent[MOTORCONTROL_MAXMOTORS];

	double motorPWMDesired[MOTORCONTROL_MAXMOTORS];
	double motorAcceleration[MOTORCONTROL_MAXMOTORS];

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;

} typedef CPhidgetMotorControlInfo;
#endif


#endif
