#include "stdafx.h"
#include "cphidgetservo.h"
#include "cusb.h"
#include "csocket.h"
#include "cthread.h"

CSENDPACKET_BUF(Servo, outputPacket, outputPacketLen)
CMAKEPACKET_BUF(Servo, outputPacket, outputPacketLen)

CFHANDLE(Servo,MotorPosition) int, double), void *userPtr)
ASGNFPTR(Servo,MotorPosition)

CPHIDGETDATA(Servo)
	int i;
	unsigned short temp;

	TESTPTR(phid)

	for (i = 0; i < 4; i++)
	{
		temp = (((unsigned short)buffer[i << 1]) << 5) + buffer[(i << 1) + 1];
		if (phid->microsecond_pulse[i] == 65535)
			phid->microsecond_pulse[i] = temp;
			
		if (temp != phid->microsecond_Echo[i])
		{
			phid->microsecond_Echo[i]	= temp;
			FIRE(MotorPosition) i, (((double)phid->microsecond_Echo[i]) - 243.8) / 10.6);
		}
		phid->microsecond_Echo[i]	= temp;
	}
	return EPHIDGET_OK;
}

CGET(Servo,NumMotors,int)
	TESTPTRS(phid,pVal) 
	MASGN1(phid.attr.servo.numMotors)
}

CGETINDEX(Servo,MotorPosition,double)
	TESTPTRS(phid,pVal) 
	TESTRNG1(phid.attr.servo.numMotors)
	if (phid->microsecond_Echo[Index] == 65535)
			return EPHIDGET_UNKNOWNVAL;
	*pVal = (((double)phid->microsecond_Echo[Index]) - 243.8) / 10.6;
	return EPHIDGET_OK;
}

CSETINDEX(Servo,MotorPosition,double)
	unsigned char buffer[20];
	int i, res;
	TESTPTR(phid) 
	TESTRNG1(phid.attr.servo.numMotors)

	for (i = 0; i<8; i++)
		buffer[i] = 0;

	if (((-23) > newVal) || (232 < newVal))
		return EPHIDGET_INVALIDARG;

	if(phid->phid.networkInfo)
		ADDNETWORKKEYINDEXED(Position, "%lf")
	else
	{
		CThread_mutex_lock(&phid->phid.writelock);

		phid->microsecond_pulse[Index] = (int)(newVal * 10.6 + 243.8);

		if ((phid->phid.deviceVersion >= 300) && (phid->phid.deviceVersion < 400))
		{
			for (i = 0; i<4; i++)
			{
				if (phid->microsecond_pulse[i] == 65535)
					phid->microsecond_pulse[i] = 0;
				if (!(phid->fullStateEcho)) 
				{		
					if (phid->microsecond_pulse[i] != phid->microsecond_Echo[i])
					{
						phid->microsecond_Echo[i]	= phid->microsecond_pulse[i];
						FIRE(MotorPosition) i, (((double)phid->microsecond_Echo[i]) - 243.8) / 10.6);
					}
				}
			}
		}

		if (CPhidget_isAttached(&phid->phid))
		{
			if ((phid->phid.deviceVersion >= 300) && (phid->phid.deviceVersion < 400))
			{
				buffer[0] = (unsigned char)phid->microsecond_pulse[0] & 0xFF;
				buffer[1] = (unsigned char)(phid->microsecond_pulse[0] >> 8);
				buffer[2] = (unsigned char)phid->microsecond_pulse[1] & 0xFF;
				buffer[1] |= ((phid->microsecond_pulse[1] >> 8) * 16);
				buffer[3] = (unsigned char)phid->microsecond_pulse[2] & 0xFF;
				buffer[4] = (unsigned char)(phid->microsecond_pulse[2] >> 8);
				buffer[5] = (unsigned char)phid->microsecond_pulse[3] & 0xFF;
				buffer[4] |= ((phid->microsecond_pulse[3] >> 8) * 16);
			}
			if (phid->phid.deviceVersion == 200)
			{
				buffer[0] = (unsigned char)(Index);
				if (phid->phid.attr.servo.numMotors == 4)
				{
					if (Index == 1) buffer[0] = 3;
					if (Index == 0) buffer[0] = 2;
					if (Index == 3) buffer[0] = 1;
					if (Index == 2) buffer[0] = 0;
				}	

				buffer[1] = (unsigned char)(phid->microsecond_pulse[Index] / 10.6);
				buffer[2] = 0;
				buffer[3] = 0;
			}
			res = _sendpacket(phid, buffer, phid->phid.outputReportByteLength);
			CThread_mutex_unlock(&phid->phid.writelock);
			return res;
		}
		
		CThread_mutex_unlock(&phid->phid.writelock);
		return EPHIDGET_NOTATTACHED;
	}
	return EPHIDGET_OK;
}

CPHIDGETINIT(Servo)
	int i;
	if (phid->phid.deviceVersion >= 313)
		phid->fullStateEcho = PTRUE;
		
	for (i = 0; i<4; i++)
	{
		phid->microsecond_pulse[i] = 65535;
		phid->microsecond_Echo[i] = 65535;
		phid->servoPosition[i] = -23;
	}
	return EPHIDGET_OK;
}

CCREATE(Servo, PHIDDEF_SERVO)
