#ifndef __CPHIDGETSTEPPER
#define __CPHIDGETSTEPPER


DPHANDLE(Stepper)

CHDRSTANDARD(Stepper)
CHDRGET(Stepper,NumInputs,PINTEGER)
CHDRGET(Stepper,NumMotors,PINTEGER)
CHDRGETINDEX(Stepper,InputState,PINTEGER)
CHDRGETSETINDEX(Stepper,Acceleration,PDOUBLE)
CHDRGETSETINDEX(Stepper,MotorSpeed,PDOUBLE)
CHDRGETSETINDEX(Stepper,MotorPosition,long long)

CHDREVENTINDEX(Stepper,InputChange,PINTEGER)
CHDREVENTINDEX(Stepper,PositionChange,long long)
CHDREVENTINDEX(Stepper,SpeedChange,PDOUBLE)


#ifndef EXTERNALPROTO
#define STEPPER_MAXSTEPPERS 8
#define STEPPER_MAXINPUTS 8
struct _CPhidgetStepper{
	CPhidget phid;
          
	int (CCONV *fptrPositionChange)(CPhidgetStepperHandle, void *, int, long long);        
	int (CCONV *fptrSpeedChange)(CPhidgetStepperHandle, void *, int, double);            
	int (CCONV *fptrInputChange)(CPhidgetStepperHandle, void *, int, int);           

	void *fptrPositionChangeptr;
	void *fptrInputChangeptr;
	void *fptrSpeedChangeptr;

	unsigned char inputStates[STEPPER_MAXINPUTS];
	long long motorPositionCurrent[STEPPER_MAXSTEPPERS];
	long long motorPositionDesired[STEPPER_MAXSTEPPERS];
	double motorAcceleration[STEPPER_MAXSTEPPERS];
	double motorSpeedCurrent[STEPPER_MAXSTEPPERS];
	double motorSpeedDesired[STEPPER_MAXSTEPPERS];

	unsigned char outputPacket[8];
	unsigned int outputPacketLen;

} typedef CPhidgetStepperInfo;
#endif


#endif

