#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <assert.h>
#include "plist.h"

int
print_int(const void *k, const void *v, void *arg)
{
	printf("%d\n", (int)k);
}

int
main(void)
{
	plist_node_t *root = NULL;
	void *oldv = NULL;

	assert(plist_add((void *)5, (void *)5, &root));
	assert(plist_add((void *)3, (void *)3, &root));
	assert(plist_add((void *)7, (void *)7, &root));
	assert(plist_contains((void *)7, root, &oldv));
	assert((int)oldv == 7);
	assert(plist_contains((void *)7, root, NULL));
	assert(!plist_contains((void *)4, root, NULL));
	printf("inorder:\n");
	plist_walk(root, print_int, 0);
	assert(root);
	assert(plist_remove((void *)7, &root, &oldv));
	assert(oldv == (void *)7);
	printf("inorder (after removal of 7):\n");
	plist_walk(root, print_int, 0);

	assert(plist_remove((void *)3, &root, &oldv));
	assert(root);
	assert(plist_remove((void *)5, &root, &oldv));
	assert(!root);
	plist_clear(&root);
	assert(!root);
	printf("after clear, inorder:\n");
	plist_walk(root, print_int, 0);
}
